% Exercise 2: Attenuation of a Collimated Beam
% Assumptions: 
%   + photon can be: absorbed, transmitted but NOT scattered
%   + same index of refraction: no refraction
%   + homogeneous medium

% Parameters
n = 10000;      % Number of photons
seed = 1;       % Seed for random number generator
a = 1;          % Absorption in m^{-1}

% Initialization
rng(seed);
z=NaN(n,1);

% Main loop
for i=1:n
  % Move photon
  z(i) = -log(rand)/a; % Path length
end

% Plot Results
% Plot Monte Carlo simulation results
figure(21); clf(21);
dz = 0.2;
max_depth = 10;
hist(z,0.1:dz:max_depth);
xlim([0 max_depth]);
xlabel('Depth (m)');
ylabel('Number of photons absorbed');

% Compare results 
hold('on');
interval = [0:dz:max_depth]';
plot(interval, dz*n*a*exp(-a*[1:size(interval,1)]*dz), 'LineWidth', 2);
